package hterhors.editor;

import java.util.ArrayList;

import org.eclipse.jface.text.ITextViewer;
import org.eclipse.jface.text.contentassist.CompletionProposal;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.text.contentassist.IContentAssistProcessor;
import org.eclipse.jface.text.contentassist.IContextInformation;
import org.eclipse.jface.text.contentassist.IContextInformationValidator;

/**
 * @author  Hendrik
 */
class ISRContentAssistantIgnoreRuleProcessor implements IContentAssistProcessor {
	private final IContextInformation[] NO_CONTEXTS = {};
	private ICompletionProposal[] NO_COMPLETIONS = {};
	private int override = 0;
	private String preSpace = "";
	protected static final String lineSeparator = System
			.getProperty("line.separator");

	/**
	 * Use this method to set the size for overriding by using content-assistant.
	 * @param override  The size to be override.
	 * @uml.property  name="override"
	 */
	public void setOverride(int override) {
		this.override = override;
	}

	@Override
	public ICompletionProposal[] computeCompletionProposals(ITextViewer viewer,
			int offset) {
		try {
			ArrayList<CompletionProposal> result = new ArrayList<CompletionProposal>();

			result.add(new CompletionProposal(
					preSpace + "newTerminal ",
					offset,
					override,
					preSpace.length(),
					null,
					"New terminal",
					null,
					"\"TERMINAL\" symbols are sequences of letters from the set [a-zA-Z_\\-\\\"0-9].\n"
							+ "They must be started by a letter from the subset [a-zA-Z_\\\"]."));
			return (ICompletionProposal[]) result
					.toArray(new ICompletionProposal[result.size()]);
		} catch (Exception e) {
			e.printStackTrace();
			return NO_COMPLETIONS;
		}
	}

	@Override
	public IContextInformation[] computeContextInformation(ITextViewer viewer,
			int offset) {
		return NO_CONTEXTS;
	}

	@Override
	public char[] getCompletionProposalAutoActivationCharacters() {
		return null;
	}

	@Override
	public char[] getContextInformationAutoActivationCharacters() {
		return null;
	}

	@Override
	public IContextInformationValidator getContextInformationValidator() {
		return null;
	}

	@Override
	public String getErrorMessage() {
		return "ERR";
	}
}
