package hterhors.editor;

import hterhors.editor.scanners.ISRPartitionScanner;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.FastPartitioner;
import org.eclipse.ui.editors.text.FileDocumentProvider;

public class ISRDocumentProvider extends FileDocumentProvider {
	
	@Override
	protected IDocument createDocument(Object element) throws CoreException {
		IDocument document = super.createDocument(element);
		if (document != null) {
			IDocumentPartitioner partitioner = new FastPartitioner(
					new ISRPartitionScanner(), new String[] {
							ISRPartitionScanner.ISR_IGNORE,
							ISRPartitionScanner.ISR_RULE,
					});
			partitioner.connect(document);
			document.setDocumentPartitioner(partitioner);
		}
		return document;
	}

	/**
	 * @uml.property  name="iSRPartitionScanner"
	 * @uml.associationEnd  inverse="iSRDocumentProvider:hterhors.editor.scanners.ISRPartitionScanner"
	 */
	private ISRPartitionScanner isrPartitionScanner;

	/**
	 * Getter of the property <tt>iSRPartitionScanner</tt>
	 * @return  Returns the isrPartitionScanner.
	 * @uml.property  name="iSRPartitionScanner"
	 */
	public ISRPartitionScanner getISRPartitionScanner() {
		return isrPartitionScanner;
	}

	/**
	 * Setter of the property <tt>iSRPartitionScanner</tt>
	 * @param iSRPartitionScanner  The isrPartitionScanner to set.
	 * @uml.property  name="iSRPartitionScanner"
	 */
	public void setISRPartitionScanner(ISRPartitionScanner isrPartitionScanner) {
		this.isrPartitionScanner = isrPartitionScanner;
	}
}