package hterhors.editor.format;

import java.util.StringTokenizer;

import org.eclipse.jface.text.formatter.IFormattingStrategy;

public class RuleFormattingStrategy implements IFormattingStrategy {

	protected static final String lineSeparator = System
			.getProperty("line.separator");

	public RuleFormattingStrategy() {
		super();
	}

	public void formatterStarts(String initialIndentation) {
	}

	public String format(String content, boolean isLineStart,
			String indentation, int[] positions) {
		content = content.replace(lineSeparator, " ");
		content = content.replaceAll("\\s+", " ");
		content = content.replace("\t", " ");
		StringTokenizer stringTokenizer = new StringTokenizer(content);
		String space = "";
		if (stringTokenizer.hasMoreTokens()) {
			String token = stringTokenizer.nextToken();
			for (int i = 0; i < token.length(); i++) {
				space += " ";
			}
		}
		content = content.replace("|", lineSeparator + space + "|");
		content = content.replace(";", ";" + lineSeparator + lineSeparator);
		return content;

	}

	public void formatterStops() {
	}

}