package hterhors.editor.helper;

/**
 * @author  Hendrik
 */
public class Word {
	/**
	 * @uml.property  name="beginningOffset"
	 */
	private int beginningOffset = 0;
	/**
	 * @uml.property  name="endOffset"
	 */
	private int endOffset = 0;
	/**
	 * @uml.property  name="word"
	 */
	private StringBuffer word = new StringBuffer();
	private String document;
	private int offset;
	/**
	 * @uml.property  name="isNull"
	 */
	private boolean isNull;

	public Word(int offset, String document) {
		this.offset = offset;
		this.document = document;
		calculate();
	}
	
	

	/**
	 * @return
	 * @uml.property  name="isNull"
	 */
	public boolean isNull() {
		return isNull;
	}


	/**
	 * @return
	 * @uml.property  name="beginningOffset"
	 */
	public int getBeginningOffset() {
		return offset - beginningOffset;
	}

	/**
	 * @return
	 * @uml.property  name="endOffset"
	 */
	public int getEndOffset() {
		return offset + endOffset;
	}

	/**
	 * @return
	 * @uml.property  name="word"
	 */
	public String getWord() {
		return word.toString();
	}

	private void calculate() {
		char c = document.charAt(offset);
		if (Character.isWhitespace(c) || offset == 0) {
			isNull = true;
			return;
		} else {
			word.append(c);
		}
		while (true) {
			beginningOffset++;
			if (offset - beginningOffset >= 0) {
				c = document.charAt(offset - beginningOffset);
				if (Character.isWhitespace(c)) {
					break;
				} else {
					word.append(c);
				}
			} else {
				break;
			}
		}
		word = word.reverse();
		while (true) {
			endOffset++;
			if (offset + endOffset < document.length()) {
				c = document.charAt(offset + endOffset);
				if (Character.isWhitespace(c)) {
					break;
				} else {
					word.append(c);
				}
			} else {
				break;
			}
		}
	}
}