package hterhors.editor.hoverinfos;

import hterhors.editor.helper.Word;
import hterhors.editor.markers.MarkerContainer;
import hterhors.editor.markers.ISRValidationObject;
import hterhors.editor.markers.IsrRuleValidator;

import java.util.StringTokenizer;

import org.eclipse.jface.text.IRegion;
import org.eclipse.jface.text.ITextHover;
import org.eclipse.jface.text.ITextViewer;
import org.eclipse.jface.text.Region;
import org.eclipse.jface.text.source.ISourceViewer;

public class GenerateHoverInfos implements ITextHover {

	public GenerateHoverInfos(ISourceViewer sourceViewer, String contentType) {
	}

	@Override
	public String getHoverInfo(ITextViewer viewer, IRegion region) {
		String document = viewer.getDocument().get();
		int regOff;
		Word word = new Word(regOff = region.getOffset(), document);
		if (word.isNull()) {
			return null;
		}
		for (ISRValidationObject err : MarkerContainer.getErrors(document)) {
			if (regOff >= err.getColumnStart() && regOff <= err.getColumnEnd()) {
				return err.getErrorMessage();
			}
		}
		for (ISRValidationObject warn : MarkerContainer.getWarnings(document)) {
			if (regOff >= warn.getColumnStart()
					&& regOff <= warn.getColumnEnd()) {
				return warn.getErrorMessage();
			}
		}
		boolean isIndex = false;
		if (word.getWord().matches(IsrRuleValidator.NON_TERMINAL + "(;?|:?)")) {
			String text = word.getWord().replace(";", "").replace(":", "");
			int begin = document.indexOf(text);
			do {
				StringTokenizer stringTokenizer = new StringTokenizer(
						document.substring(begin));
				while (stringTokenizer.hasMoreTokens()) {
					String cT = stringTokenizer.nextToken();
					if (cT.matches(IsrRuleValidator.NON_TERMINAL_DECLARATION)) {
						isIndex = true;
					} else if (cT.matches(IsrRuleValidator.NON_TERMINAL)
							&& stringTokenizer.hasMoreTokens()) {
						if (stringTokenizer.nextToken().matches(
								IsrRuleValidator.C)) {
							isIndex = true;
						}
					}
					break;
				}
				if (isIndex) {
					break;
				}
			} while ((begin = document.indexOf(text, begin + text.length())) != -1
					|| !isIndex);
			StringTokenizer hoverInfo;
			hoverInfo = new StringTokenizer(document.substring(begin), ";",
					true);
			if (hoverInfo.hasMoreTokens()) {
				return "\nDeclaration: \n\n " + hoverInfo.nextToken() + " ;\n";
			} else {
				return null;
			}
		}
		return null;
	}

	@Override
	public IRegion getHoverRegion(ITextViewer viewer, int offset) {
		return new Region(offset, 20);
	}

}
