package hterhors.editor.markers;

/**
 * @author  Hendrik
 */
public class ISRValidationObject {
	/**
	 * @uml.property  name="errorMessage"
	 */
	private String errorMessage;
	/**
	 * @uml.property  name="lineNumber"
	 */
	private int lineNumber;
	/**
	 * @uml.property  name="columnStart"
	 */
	private int columnStart;
	/**
	 * @uml.property  name="columnEnd"
	 */
	private int columnEnd;
	/**
	 * @uml.property  name="type"
	 * @uml.associationEnd  
	 */
	private EValidType type;

	public ISRValidationObject(String errorMessage, int lineNumber,
			int columnStart, int columnEnd, EValidType type) {
		this.errorMessage = errorMessage;
		this.lineNumber = lineNumber;
		this.columnStart = columnStart;
		this.columnEnd = columnEnd;
		this.type = type;
	}

	/**
	 * @return
	 * @uml.property  name="errorMessage"
	 */
	public String getErrorMessage() {
		return errorMessage;
	}

	/**
	 * @return
	 * @uml.property  name="lineNumber"
	 */
	public int getLineNumber() {
		return lineNumber;
	}

	/**
	 * @return
	 * @uml.property  name="columnStart"
	 */
	public int getColumnStart() {
		return columnStart;
	}

	/**
	 * @return
	 * @uml.property  name="columnEnd"
	 */
	public int getColumnEnd() {
		return columnEnd;
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append(type + " on ").append(" line ").append(lineNumber)
				.append(", column starts ").append(columnStart)
				.append(", column ends ").append(columnEnd).append(": ")
				.append(errorMessage).append("\n");
		return buf.toString();
	}

	/**
	 * @author   Hendrik
	 */
	enum EValidType {
		/**
		 * @uml.property  name="error"
		 * @uml.associationEnd  
		 */
		Error, /**
		 * @uml.property  name="warning"
		 * @uml.associationEnd  
		 */
		Warning;
	}
}
