package hterhors.editor.markers;

import java.util.List;

public class MarkerContainer {

	private static List<ISRValidationObject> errors = null;
	private static List<ISRValidationObject> warnings = null;
	private static int hashCode = 0;

	private static void calcErrAndWarn(String document) {
				isDirty(document);
				errors = IsrRuleValidator.parseErrors(document);
				warnings = IsrRuleValidator.parseWarnings(document);

	}

	public synchronized static boolean isDirty(String document) {
		int tmp = document.hashCode();
		if (tmp == hashCode) {
			return false;
		} else {
			hashCode = tmp;
			return true;
		}
	}

	public static List<ISRValidationObject> getErrors(String document) {
		calcErrAndWarn(document);
		return errors;
	}

	public static List<ISRValidationObject> getWarnings(String document) {
		calcErrAndWarn(document);
		return warnings;
	}

}
