package hterhors.editor.sentenceparser.grammar;

/* Copyright (c) 2003, Carl Burch. License information is located in the
 * edu.csbsju.socs.grammar.Main source code and at
 * www.cburch.com/proj/grammar/. */

/**
 * @author  Hendrik
 */
public class Tree {
	/**
	 * @uml.property  name="null_children"
	 * @uml.associationEnd  multiplicity="(0 -1)"
	 */
	private static final Tree[] null_children = {};

	/**
	 * @uml.property  name="data"
	 */
	private Object data;
	/**
	 * @uml.property  name="children"
	 * @uml.associationEnd  multiplicity="(0 -1)"
	 */
	private Tree[] children;
	private boolean is_leaf = false;

	protected Tree(Object data) {
		this(data, null_children);
		this.is_leaf = true;
	}

	protected Tree(Object data, Tree[] children) {
		this.data = data;
		this.children = children;
	}

	/**
	 * @return
	 * @uml.property  name="data"
	 */
	public Object getData() {
		return data;
	}

	/**
	 * @param data
	 * @uml.property  name="data"
	 */
	public void setData(Object data) {
		this.data = data;
	}

	public Tree getChild(int which) {
		return children[which];
	}

	/**
	 * @return
	 * @uml.property  name="children"
	 */
	public Tree[] getChildren() {
		return children;
	}

	public boolean isLeaf() {
		return is_leaf;
	}

	public static Tree createNode(Object data, Tree[] children) {
		return new Tree(data, children);
	}

	public static Tree createLeaf(Object data) {
		return new Tree(data);
	}
}
