package hterhors.editor.sentenceparser.grammar;

/* Copyright (c) 2003, Carl Burch. License information is located in the
 * edu.csbsju.socs.grammar.Main source code and at
 * www.cburch.com/proj/grammar/. */

import hterhors.editor.zest.SentenceGraphBuilder;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.font.LineMetrics;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JPanel;

/**
 * @author  Hendrik
 */
public class TreeBuilder {

	/**
	 * @uml.property  name="tree"
	 * @uml.associationEnd  
	 */
	private Tree tree = null;
	private ArrayList tree_data = new ArrayList();

	public TreeBuilder() {
	}

	public void setTree(Tree value, String sentence) {
		if (value == null)
			value = new Tree("\"" + sentence + "\" is not in grammar!");
		this.tree = value;
		this.tree_data = null;
		tree_data = new ArrayList();
		autoArrangeSub(value);
		SentenceGraphBuilder.addInput(tree_data, null);
	}

	private TreeData autoArrangeSub(Tree t) {
		Tree[] children = t.getChildren();

		TreeData child = null;

		if (children.length == 0) {
		} else {
			TreeData last = null;
			for (int i = 0; i < children.length; i++) {
				TreeData data = autoArrangeSub(children[i]);
				if (last == null)
					child = data;
				else
					last.sibling = data;
				last = data;
			}
		}

		TreeData ret = new TreeData(t);
		ret.child = child;
		for (TreeData n = child; n != null; n = n.sibling) {
			n.parent = ret;
		}
		tree_data.add(ret);
		return ret;
	}
}
