package hterhors.editor.sentenceparser.grammar;

/* Copyright (c) 2003, Carl Burch. License information is located in the
 * edu.csbsju.socs.grammar.Main source code and at
 * www.cburch.com/proj/grammar/. */

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;

/**
 * @author  Hendrik
 */
public class TreeFrame extends JFrame {
	private class FileMenu extends JMenu implements ActionListener {
		private JMenuItem close = new JMenuItem();

		private FileMenu() {
			add(close);
			close.addActionListener(this);
		}

		private void renewStrings() {
			this.setText("Menu");
			close.setText("Close");
		}

		public void actionPerformed(ActionEvent e) {
			Object src = e.getSource();
			if (src == close)
				TreeFrame.this.dispose();
		}

	}

	private class WindowCloser extends WindowAdapter {
		public void windowClosing(WindowEvent e) {
			TreeFrame.this.dispose();
		}
	}

	/**
	 * @uml.property  name="file_menu"
	 * @uml.associationEnd  
	 */
	private FileMenu file_menu = new FileMenu();
	/**
	 * @uml.property  name="panel"
	 * @uml.associationEnd  
	 */
	private TreePanel panel = new TreePanel();
	private JFileChooser chooser = new JFileChooser(".");
	private JScrollPane panel_scroll;

	public TreeFrame() {
		addWindowListener(new WindowCloser());

		JMenuBar menubar = new JMenuBar();
		menubar.add(file_menu);
		setJMenuBar(menubar);

		panel_scroll = new JScrollPane(panel);
		getContentPane().add(panel_scroll, BorderLayout.CENTER);
	}

	public void renewStrings(String title) {
		this.setTitle(title);
		file_menu.renewStrings();
		pack();

		JFileChooser newch = new JFileChooser();
		java.io.File f = chooser.getCurrentDirectory();
		if (f != null)
			newch.setCurrentDirectory(f);
		f = chooser.getSelectedFile();
		if (f != null)
			newch.setSelectedFile(f);
		chooser = newch;
	}

	public void setTree(Tree t, String sentence) {
		panel.setTree(t, sentence);
		renewStrings(sentence);
	}
}
