package hterhors.editor.zest;

import hterhors.editor.IISRColorConstants;
import hterhors.editor.sentenceparser.grammar.TreeData;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.zest.core.widgets.Graph;
import org.eclipse.zest.core.widgets.GraphConnection;
import org.eclipse.zest.core.widgets.GraphNode;
import org.eclipse.zest.core.widgets.ZestStyles;
import org.eclipse.zest.layouts.LayoutAlgorithm;
import org.eclipse.zest.layouts.LayoutStyles;
import org.eclipse.zest.layouts.algorithms.CompositeLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.GridLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.HorizontalShift;
import org.eclipse.zest.layouts.algorithms.HorizontalTreeLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.RadialLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.SpringLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.TreeLayoutAlgorithm;
import org.eclipse.zest.layouts.algorithms.VerticalLayoutAlgorithm;

/**
 * Buggy wegen recursion 
 * @author  Hendrik
 */
public class SentenceGraphBuilder {

	private static List<ArrayList<TreeData>> treeDatas = new ArrayList<ArrayList<TreeData>>();

	public static void getGraph(Composite parent) {
		if (treeDatas != null) {
			for (ArrayList<TreeData> treeData : treeDatas) {
				gns.clear();
				if (treeData != null) {
					Device device = parent.getDisplay()
							.getSystemColor(SWT.COLOR_GREEN).getDevice();
					final Graph graph = new Graph(parent, SWT.NONE);
					GraphNode parentNode = null;
					Iterator<TreeData> it = treeData.iterator();
					while (it.hasNext()) {
						if (it.next().parent == null) {
							parentNode = new GraphNode(graph, SWT.NONE, "$$S");
							break;
						}
					}
					parentNode.setBackgroundColor(new Color(device,
							IISRColorConstants.START_GRAPH));
					it = treeData.iterator();
					while (it.hasNext()) {
						TreeData nd = it.next();
						TreeData pd;
						if (nd.data.isLeaf()) {
							GraphNode ndNode = new GraphNode(graph, SWT.NONE,
									nd.data.getData().toString());
							add(ndNode);
							GraphNode pdNode = null;
							while (true) {
								pd = nd.parent;
								if (pd != null) {
									if (pd.parent != null) {
										pdNode = getndNod(graph, pd.data
												.getData().toString());
										add(pdNode);
										if (!pd.data.isLeaf()) {
											pdNode.setBackgroundColor(new Color(
													device,
													IISRColorConstants.NON_TERMINAL_GRAPH));
										}
										new GraphConnection(
												graph,
												ZestStyles.CONNECTIONS_DIRECTED,
												pdNode, ndNode);
									} else {
										new GraphConnection(
												graph,
												ZestStyles.CONNECTIONS_DIRECTED,
												parentNode, ndNode);
									}
									nd = pd;
									ndNode = pdNode;
								} else {
									break;
								}
							}
						}
					}

					switch (layout) {
					case TreeLayoutAlgorithm:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new TreeLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
						break;
					case HorizontalTreeLayoutAlgorithm:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new HorizontalTreeLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
						break;
					case RadialLayoutAlgorithm:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new RadialLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
						break;
					case GridLayoutAlgorithm:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new GridLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
						break;
					case VerticalLayoutAlgorithm:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new VerticalLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
						break;
					case SpringLayoutAlgorithm:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new SpringLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
						break;
					default:
						graph.setLayoutAlgorithm(
								new CompositeLayoutAlgorithm(
										LayoutStyles.NO_LAYOUT_NODE_RESIZING,
										new LayoutAlgorithm[] {
												new HorizontalTreeLayoutAlgorithm(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING),
												new HorizontalShift(
														LayoutStyles.NO_LAYOUT_NODE_RESIZING) }),
								true);
					}
				}
			}
		}
	}

	private static GraphNode getndNod(Graph graph, String ndNodeText) {
		int index;
		if ((index = contains(ndNodeText)) == -1)
			return new GraphNode(graph, SWT.NONE, ndNodeText);
		return gns.get(index);
	}

	static List<GraphNode> gns = new ArrayList<GraphNode>();

	private static void add(GraphNode ndNode) {
		if (contains(ndNode) == null) {
			gns.add(ndNode);
		}
	}

	private static GraphNode contains(GraphNode ndNode) {
		if (ndNode.getText().equals(ndNode.getText().toUpperCase())) {
			for (int i = 0; i < gns.size(); i++) {
				if (gns.get(i).getText().equals(ndNode.getText())) {
					return ndNode;
				}
			}
		}
		return null;
	}

	private static int contains(String ndNodeText) {
		if (ndNodeText.equals(ndNodeText.toUpperCase())) {
			for (int i = 0; i < gns.size(); i++) {
				if (gns.get(i).getText().equals(ndNodeText)) {
					return i;
				}
			}
		}
		return -1;
	}

	/**
	 * @uml.property  name="layout"
	 * @uml.associationEnd  
	 */
	private static ELayouts layout = ELayouts.HorizontalTreeLayoutAlgorithm;

	public static void addInput(ArrayList<TreeData> tree_data, ELayouts l) {
		SentenceGraphBuilder.treeDatas.add(tree_data);
		if (l != null)
			layout = l;
	}

	public static void clearInput() {
		SentenceGraphBuilder.treeDatas.clear();
	}
}
